'** BLEACH.BAS
'** QBasic source
DECLARE SUB SetPalette (Colour%, Red%, Green%, Blue%)
DECLARE SUB GetPalette (Colour%, Red%, Green%, Blue%)
DECLARE SUB Delay (seconds!)
DEFINT A-Z

'** User-defined TYPE to hold colors.
TYPE PalColor
  Red AS INTEGER
  Green AS INTEGER
  Blue AS INTEGER
  Grey AS INTEGER
END TYPE
DIM PalColor(255) AS PalColor

'** MCGA, 320x200x256.
SCREEN 13

'** Store the existing palette in our array.
FOR I% = 0 TO 255
  GetPalette I%, Red%, Green%, Blue%
  PalColor(I%).Red = Red%
  PalColor(I%).Green = Green%
  PalColor(I%).Blue = Blue%
  '** Find equivalent grey value for this color.
  PalColor(I%).Grey = (Red% + Green% + Blue%) \ 3
NEXT I%

'** Draw boxes of all colors in the palette.
FOR I% = 0 TO 15
  I2% = I% * 12
  FOR J% = 0 TO 15
    J2% = J% * 20
    LINE (J2%, I2%)-(J2% + 18, I2% + 10), I% * 16 + J%, BF
  NEXT J%
NEXT I%

'** Wait for a keypress before beginning 'bleach'.
SLEEP

'** Fade colors towards their grey equivalents - looks like
'**   bleaching a color photo to black and white.
'** Loop I% goes to 42 because that's the maximum number of steps
'**   a color has to be bleached to reach grey: 64 - (64 \ 3) - 1.
FOR I% = 0 TO 42
  '** Modify delay for faster or slower 'bleach'.
  Delay .1
  '** Cycle through all colors.
  FOR J% = 0 TO 255
    Red% = PalColor(J%).Red
    Green% = PalColor(J%).Green
    Blue% = PalColor(J%).Blue
    Grey% = PalColor(J%).Grey
    Red% = Red% + SGN(Grey% - Red%)
    Green% = Green% + SGN(Grey% - Green%)
    Blue% = Blue% + SGN(Grey% - Blue%)
    PalColor(J%).Red = Red%
    PalColor(J%).Green = Green%
    PalColor(J%).Blue = Blue%
    '** Set color to new value.
    SetPalette J%, Red%, Green%, Blue%
  NEXT J%
NEXT I%

'** Wait for a keypress before ending.
SLEEP

'** Restore the default palette before ending.
PALETTE

END

DEFSNG A-Z
'** Delay routine lifted from Matt Zuchowski.
SUB Delay (seconds!)
   DEF SEG = 0
   D& = FIX(seconds! * 18.20444444#)
   FOR T& = 0 TO D&
     D% = PEEK(&H46C) AND 255
     DO WHILE D% = (PEEK(&H46C) AND 255)
     LOOP
   NEXT T&
END SUB

DEFINT A-Z
SUB GetPalette (Colour%, Red%, Green%, Blue%)

OUT &H3C7, Colour%
Red% = INP(&H3C9)
Green% = INP(&H3C9)
Blue% = INP(&H3C9)

END SUB

SUB SetPalette (Colour%, Red%, Green%, Blue%)

OUT &H3C8, Colour%
OUT &H3C9, Red%
OUT &H3C9, Green%
OUT &H3C9, Blue%

END SUB

